'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _deprecated = require('../utils/deprecated');

var _deprecated2 = _interopRequireDefault(_deprecated);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isSeparatorOption(opt) {
  if (opt === null) {
    (0, _deprecated2.default)('Using null for separator option is deprecated; use { separator: true }');
    opt = { separator: true };
  }

  return typeof opt !== 'string' && opt && !!opt.separator;
}

function filterRedudantSeparators(options) {
  return options.reduce(function (opts, opt) {
    return isSeparatorOption(opt) && opts.length && isSeparatorOption(opts[opts.length - 1]) ? opts : [].concat((0, _toConsumableArray3.default)(opts), [opt]);
  }, []);
}

exports.default = filterRedudantSeparators;