'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.default = findMatchingTextIndex;

var _getOptionText = require('./getOptionText');

var _getOptionText2 = _interopRequireDefault(_getOptionText);

var _getOptionValue = require('./getOptionValue');

var _getOptionValue2 = _interopRequireDefault(_getOptionValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var toLower = function toLower() {
  var val = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];
  return (val === null || val === undefined ? '' : val).toString().toLowerCase();
};

function findMatchingTextIndex(value, options) {
  var allMatches = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  var lowerText = toLower(value);

  var foundOptions = options.reduce(function (opts, opt, index) {
    if (opt === null || opt === undefined || opt.disabled || opt.separator) {
      return opts;
    }

    var optValue = (0, _getOptionValue2.default)(opt);
    var optText = (0, _getOptionText2.default)(opt);
    var matchPosition = toLower(optText).indexOf(lowerText);

    if (optValue === value || optText && lowerText && (allMatches ? matchPosition !== -1 : matchPosition === 0)) {

      return [].concat((0, _toConsumableArray3.default)(opts), [{
        index: index,
        text: optText,
        value: optValue,
        position: matchPosition,
        lowercaseText: optText.toLowerCase()
      }]);
    }

    return opts;
  }, []);

  foundOptions.sort(function (a, b) {
    return a.position - b.position || (a.lowercaseText > b.lowercaseText ? 1 : -1);
  });

  return foundOptions.length ? foundOptions[0] : { noResult: true };
}